HSH_SECONDS_PER_HIT = 1.2;
HSH_NUMBER_OF_OT = 3;

HSH = {
  status -- 0 - default, 1 - was hs, not healed yet
  ,warningtime
};

HSHTrain = {
  status -- 0 - stopped, 1 - runned, 2 - failed
, washeal
};

HSH.status = 0;

function hsh_binded_heal()
   if (1 == HSH.status) then
      HSH.status = 0;
      hsh_message("...heal...");
      CastSpellByName("Greater Heal(Rank 4)");
   end
end

function hsh_onevent()

   if (event == "VARIABLES_LOADED") then 
      hsh_initialize(); 
   end 

   if (
         event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE"
      or event == "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE"
      or event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE"
      )
      then 
      hsh_damage(event, arg1); 
   elseif (event == "CHAT_MSG_SPELL_SELF_BUFF") then
      hsh_heal(event, arg1);
   end 
end

function hsh_initialize()
   SlashCmdList["HSH"] = hsh_command;
   SLASH_HSH1 = "/hsh";
   this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE"); 
   this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE"); 
   this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE"); 
end

function hsh_command(msg)
   if (msg == "train") then
      hsh_start_train();
   end
end

function hsh_damage(ev, arg1)
   if ( (not (nil == UnitName("target")))
      and  string.find(arg1, "Hateful Strike hits "..UnitName("target"))
      )
   then
      HSH.status = 1;
      hsh_send_alarm(UnitName("target"))
      hsh_registerheal();
   end
end

function hsh_start_train()
   hsh_message("starting train ..");
   HSHTrain.status = 1;
   Timex:AddSchedule("hsh", 2, nil, nil, hsh_train_damage);
end

function hsh_train_damage()
   HSHTrain.washeal = false;
   HSH.status = 1;
   TargetUnit("Player");
   hsh_send_alarm(UnitName("target"))
   Timex:AddSchedule("hsh", HSH_SECONDS_PER_HIT * HSH_NUMBER_OF_OT, nil, nil, hsh_train_check);
   hsh_registerheal();
end

function hsh_train_check() -- next hs incoming, check heal and add next damage event
   if (true == HSHTrain.washeal) then

      hsh_message("OK");

      local nexttime = 0;
      local h = math.random(1, 10);

      if (h < 6) then
         nexttime = nexttime + HSH_SECONDS_PER_HIT * h;
      end

      if (0 == nexttime) then
         hsh_train_damage();
      else
         Timex:AddSchedule("hsh", nexttime, nil, nil, hsh_train_damage);
      end
   else
      hsh_message("You have failed!");
      HSHTrain.status = 2;
   end
end

function hsh_heal() -- heal incoming
   HSH.status = 0;
   hsh_train_heal_report();
   hsh_unregisterheal();
   if (1 == HSHTrain.status) then
      HSHTrain.washeal = true;
   elseif (2 == HSHTrain.status) then
      HSHTrain.washeal = false;
      HSHTrain.status = 0;
   end
end

function hsh_train_heal_report()
   local t = GetTime() - HSH.warningtime;
   hsh_message("-- ".. t .." --");
end

function hsh_send_alarm(unitname)
   HSH.warningtime = GetTime();
   hsh_message("### HEAL "..unitname.." !!  ###");
   hsh_sound_alarm();
end

function hsh_message(msg)
   ChatFrame1:AddMessage(msg,1,0,1);
end

function hsh_sound_alarm()
   PlaySoundFile("Interface\\AddOns\\hsh\\Sounds\\Alarm.mp3");
end

function hsh_registerheal()
   hsh_core:RegisterEvent("CHAT_MSG_SPELL_SELF_BUFF");
end

function hsh_unregisterheal()
   hsh_core:UnregisterEvent("CHAT_MSG_SPELL_SELF_BUFF");
end
